> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Create a new virtual cluster

POST https://example.itential.io/gateway_manager/v1/virtual-clusters
Content-Type: application/json

Creates a new virtual cluster that references registered physical clusters for primary and optional backup targets.

Reference: https://docs.itential.com/itential-platform/6/api-reference/gateway-manager/gateway-manager-create-virtual-cluster

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `virtualCluster` (object, optional)
  - `cluster_id` (string, required) — Unique cluster_id for the virtual cluster across all physical and virtual clusters
  - `enabled` (boolean, required) — Whether the virtual cluster is enabled
  - `readonly` (boolean, required) — Whether the virtual cluster is in readonly mode
  - `primary_cluster_id` (string, required) — The cluster_id of the primary physical cluster
  - `groups` (list of string, required) — An array of the names of the groups that will be associated with this virtual cluster. Any group that is associated with this virtual cluster will be able to take actions on it per the roles associated with that particular group
  - `description` (string, optional) — Optional free text description
  - `backup_cluster_ids` (list of string, optional) — Ordered list of backup physical cluster IDs. Failover executes in array index order.

## Response

### 200

Result of creating the virtual cluster

- `state` (string, optional)
- `id` (string, optional)
- `message` (string, optional)

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "state": "Success",
  "id": "6710049eda530d444d141565",
  "message": "Successfully added virtual cluster: my-virtual-cluster"
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/gateway_manager/v1/virtual-clusters"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/gateway_manager/v1/virtual-clusters';
const options = {method: 'POST', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/gateway_manager/v1/virtual-clusters"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/gateway_manager/v1/virtual-clusters")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/gateway_manager/v1/virtual-clusters")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/gateway_manager/v1/virtual-clusters', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/gateway_manager/v1/virtual-clusters");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/gateway_manager/v1/virtual-clusters")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```